import { DataEngineOptions, DataItem, ListElement, MappedDataItem, PropertyMap, RenderListItemFn } from './types';
declare class DataEngine {
    data: Array<DataItem>;
    sortedData: Array<DataItem>;
    sortedDataDomArray: Array<HTMLElement>;
    propertyMap: Partial<PropertyMap>;
    renderListItem: RenderListItemFn;
    /**
     * @constructor
     */
    constructor({ data, propertyMap, renderListItem }: DataEngineOptions);
    maybeTransformData(): void;
    getItemPropProxyName(prop: string): string;
    isTopLevelItem(item: DataItem): boolean;
    sortListItems(): Array<DataItem>;
    createItemElement(item: Partial<DataItem>, nodeName?: string): HTMLElement;
    elementIsParentOfItem(node: HTMLElement, item: DataItem): boolean;
    getParentNodeOfItem(node: HTMLElement, item: DataItem, nodeName: string): HTMLElement | null;
    elementIsAncestorOfItem(node: HTMLElement, item: DataItem): boolean;
    getDirectListParentOfItem(node: HTMLElement, item: DataItem): HTMLElement | null;
    maybeAppendItemToParentDom(item: DataItem): boolean;
    getListItemsDom(): Array<HTMLElement>;
    convertDomToData(list: ListElement): Array<MappedDataItem>;
    render(): Node;
}
export default DataEngine;
